diff --git a/security/nss/gtests/google_test/gtest/scripts/release_docs.py b/security/nss/gtests/google_test/gtest/scripts/release_docs.py
index 8d24f28fdf..2ab6bbbf34 100755
--- a/security/nss/gtests/google_test/gtest/scripts/release_docs.py
+++ b/security/nss/gtests/google_test/gtest/scripts/release_docs.py
@@ -61,6 +61,7 @@ EXAMPLE
        $ svn commit -m "release wiki pages for v2.6"
 """
 
+from __future__ import print_function
 __author__ = 'wan@google.com (Zhanyong Wan)'
 
 import os
@@ -127,11 +128,11 @@ class WikiBrancher(object):
   def BranchFiles(self):
     """Branches the .wiki files needed to be branched."""
 
-    print 'Branching %d .wiki files:' % (len(self.files_to_branch),)
+    print('Branching %d .wiki files:' % (len(self.files_to_branch),))
     os.chdir(self.wiki_dir)
     for f in self.files_to_branch:
       command = 'svn cp %s %s%s' % (f, self.version_prefix, f)
-      print command
+      print(command)
       os.system(command)
 
   def UpdateLinksInBranchedFiles(self):
@@ -139,10 +140,10 @@ class WikiBrancher(object):
     for f in self.files_to_branch:
       source_file = os.path.join(self.wiki_dir, f)
       versioned_file = os.path.join(self.wiki_dir, self.version_prefix + f)
-      print 'Updating links in %s.' % (versioned_file,)
-      text = file(source_file, 'r').read()
+      print('Updating links in %s.' % (versioned_file,))
+      text = open(source_file, 'r').read()
       new_text = self.search_for_re.sub(self.replace_with, text)
-      file(versioned_file, 'w').write(new_text)
+      open(versioned_file, 'w').write(new_text)
 
 
 def main():
diff --git a/security/nss/gtests/google_test/gtest/scripts/upload.py b/security/nss/gtests/google_test/gtest/scripts/upload.py
index eba571142f..c1df773b09 100755
--- a/security/nss/gtests/google_test/gtest/scripts/upload.py
+++ b/security/nss/gtests/google_test/gtest/scripts/upload.py
@@ -46,7 +46,8 @@ against by using the '--rev' option.
 # This code is derived from appcfg.py in the App Engine SDK (open source),
 # and from ASPN recipe #146306.
 
-import cookielib
+from __future__ import print_function
+import six.moves.http_cookiejar
 import getpass
 import logging
 import md5
@@ -57,9 +58,10 @@ import re
 import socket
 import subprocess
 import sys
-import urllib
-import urllib2
-import urlparse
+import six.moves.urllib.request, six.moves.urllib.parse, six.moves.urllib.error
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
+import six.moves.urllib.parse
+import six
 
 try:
   import readline
@@ -94,15 +96,15 @@ def GetEmail(prompt):
       last_email = last_email_file.readline().strip("\n")
       last_email_file.close()
       prompt += " [%s]" % last_email
-    except IOError, e:
+    except IOError as e:
       pass
-  email = raw_input(prompt + ": ").strip()
+  email = input(prompt + ": ").strip()
   if email:
     try:
       last_email_file = open(last_email_file_name, "w")
       last_email_file.write(email)
       last_email_file.close()
-    except IOError, e:
+    except IOError as e:
       pass
   else:
     email = last_email
@@ -118,20 +120,20 @@ def StatusUpdate(msg):
     msg: The string to print.
   """
   if verbosity > 0:
-    print msg
+    print(msg)
 
 
 def ErrorExit(msg):
   """Print an error message to stderr and exit."""
-  print >>sys.stderr, msg
+  print(msg, file=sys.stderr)
   sys.exit(1)
 
 
-class ClientLoginError(urllib2.HTTPError):
+class ClientLoginError(six.moves.urllib.error.HTTPError):
   """Raised to indicate there was an error authenticating with ClientLogin."""
 
   def __init__(self, url, code, msg, headers, args):
-    urllib2.HTTPError.__init__(self, url, code, msg, headers, None)
+    six.moves.urllib.error.HTTPError.__init__(self, url, code, msg, headers, None)
     self.args = args
     self.reason = args["Error"]
 
@@ -177,10 +179,10 @@ class AbstractRpcServer(object):
   def _CreateRequest(self, url, data=None):
     """Creates a new urllib request."""
     logging.debug("Creating request for: '%s' with payload:\n%s", url, data)
-    req = urllib2.Request(url, data=data)
+    req = six.moves.urllib.request.Request(url, data=data)
     if self.host_override:
       req.add_header("Host", self.host_override)
-    for key, value in self.extra_headers.iteritems():
+    for key, value in self.extra_headers.items():
       req.add_header(key, value)
     return req
 
@@ -204,7 +206,7 @@ class AbstractRpcServer(object):
       account_type = "HOSTED"
     req = self._CreateRequest(
         url="https://www.google.com/accounts/ClientLogin",
-        data=urllib.urlencode({
+        data=six.moves.urllib.parse.urlencode({
             "Email": email,
             "Passwd": password,
             "service": "ah",
@@ -218,7 +220,7 @@ class AbstractRpcServer(object):
       response_dict = dict(x.split("=")
                            for x in response_body.split("\n") if x)
       return response_dict["Auth"]
-    except urllib2.HTTPError, e:
+    except six.moves.urllib.error.HTTPError as e:
       if e.code == 403:
         body = e.read()
         response_dict = dict(x.split("=", 1) for x in body.split("\n") if x)
@@ -240,14 +242,14 @@ class AbstractRpcServer(object):
     continue_location = "http://localhost/"
     args = {"continue": continue_location, "auth": auth_token}
     req = self._CreateRequest("http://%s/_ah/login?%s" %
-                              (self.host, urllib.urlencode(args)))
+                              (self.host, six.moves.urllib.parse.urlencode(args)))
     try:
       response = self.opener.open(req)
-    except urllib2.HTTPError, e:
+    except six.moves.urllib.error.HTTPError as e:
       response = e
     if (response.code != 302 or
         response.info()["location"] != continue_location):
-      raise urllib2.HTTPError(req.get_full_url(), response.code, response.msg,
+      raise six.moves.urllib.error.HTTPError(req.get_full_url(), response.code, response.msg,
                               response.headers, response.fp)
     self.authenticated = True
 
@@ -270,34 +272,34 @@ class AbstractRpcServer(object):
       credentials = self.auth_function()
       try:
         auth_token = self._GetAuthToken(credentials[0], credentials[1])
-      except ClientLoginError, e:
+      except ClientLoginError as e:
         if e.reason == "BadAuthentication":
-          print >>sys.stderr, "Invalid username or password."
+          print("Invalid username or password.", file=sys.stderr)
           continue
         if e.reason == "CaptchaRequired":
-          print >>sys.stderr, (
+          print((
               "Please go to\n"
               "https://www.google.com/accounts/DisplayUnlockCaptcha\n"
-              "and verify you are a human.  Then try again.")
+              "and verify you are a human.  Then try again."), file=sys.stderr)
           break
         if e.reason == "NotVerified":
-          print >>sys.stderr, "Account not verified."
+          print("Account not verified.", file=sys.stderr)
           break
         if e.reason == "TermsNotAgreed":
-          print >>sys.stderr, "User has not agreed to TOS."
+          print("User has not agreed to TOS.", file=sys.stderr)
           break
         if e.reason == "AccountDeleted":
-          print >>sys.stderr, "The user account has been deleted."
+          print("The user account has been deleted.", file=sys.stderr)
           break
         if e.reason == "AccountDisabled":
-          print >>sys.stderr, "The user account has been disabled."
+          print("The user account has been disabled.", file=sys.stderr)
           break
         if e.reason == "ServiceDisabled":
-          print >>sys.stderr, ("The user's access to the service has been "
-                               "disabled.")
+          print(("The user's access to the service has been "
+                               "disabled."), file=sys.stderr)
           break
         if e.reason == "ServiceUnavailable":
-          print >>sys.stderr, "The service is not available; try again later."
+          print("The service is not available; try again later.", file=sys.stderr)
           break
         raise
       self._GetAuthCookie(auth_token)
@@ -334,7 +336,7 @@ class AbstractRpcServer(object):
         args = dict(kwargs)
         url = "http://%s%s" % (self.host, request_path)
         if args:
-          url += "?" + urllib.urlencode(args)
+          url += "?" + six.moves.urllib.parse.urlencode(args)
         req = self._CreateRequest(url=url, data=payload)
         req.add_header("Content-Type", content_type)
         try:
@@ -342,7 +344,7 @@ class AbstractRpcServer(object):
           response = f.read()
           f.close()
           return response
-        except urllib2.HTTPError, e:
+        except six.moves.urllib.error.HTTPError as e:
           if tries > 3:
             raise
           elif e.code == 401:
@@ -372,35 +374,35 @@ class HttpRpcServer(AbstractRpcServer):
     Returns:
       A urllib2.OpenerDirector object.
     """
-    opener = urllib2.OpenerDirector()
-    opener.add_handler(urllib2.ProxyHandler())
-    opener.add_handler(urllib2.UnknownHandler())
-    opener.add_handler(urllib2.HTTPHandler())
-    opener.add_handler(urllib2.HTTPDefaultErrorHandler())
-    opener.add_handler(urllib2.HTTPSHandler())
+    opener = six.moves.urllib.request.OpenerDirector()
+    opener.add_handler(six.moves.urllib.request.ProxyHandler())
+    opener.add_handler(six.moves.urllib.request.UnknownHandler())
+    opener.add_handler(six.moves.urllib.request.HTTPHandler())
+    opener.add_handler(six.moves.urllib.request.HTTPDefaultErrorHandler())
+    opener.add_handler(six.moves.urllib.request.HTTPSHandler())
     opener.add_handler(urllib2.HTTPErrorProcessor())
     if self.save_cookies:
       self.cookie_file = os.path.expanduser("~/.codereview_upload_cookies")
-      self.cookie_jar = cookielib.MozillaCookieJar(self.cookie_file)
+      self.cookie_jar = six.moves.http_cookiejar.MozillaCookieJar(self.cookie_file)
       if os.path.exists(self.cookie_file):
         try:
           self.cookie_jar.load()
           self.authenticated = True
           StatusUpdate("Loaded authentication cookies from %s" %
                        self.cookie_file)
-        except (cookielib.LoadError, IOError):
+        except (six.moves.http_cookiejar.LoadError, IOError):
           # Failed to load cookies - just ignore them.
           pass
       else:
         # Create an empty cookie file with mode 600
-        fd = os.open(self.cookie_file, os.O_CREAT, 0600)
+        fd = os.open(self.cookie_file, os.O_CREAT, 0o600)
         os.close(fd)
       # Always chmod the cookie file
-      os.chmod(self.cookie_file, 0600)
+      os.chmod(self.cookie_file, 0o600)
     else:
       # Don't save cookies across runs of update.py.
-      self.cookie_jar = cookielib.CookieJar()
-    opener.add_handler(urllib2.HTTPCookieProcessor(self.cookie_jar))
+      self.cookie_jar = six.moves.http_cookiejar.CookieJar()
+    opener.add_handler(six.moves.urllib.request.HTTPCookieProcessor(self.cookie_jar))
     return opener
 
 
@@ -575,7 +577,7 @@ def RunShellWithReturnCode(command, print_output=False,
       line = p.stdout.readline()
       if not line:
         break
-      print line.strip("\n")
+      print(line.strip("\n"))
       output_array.append(line)
     output = "".join(output_array)
   else:
@@ -583,7 +585,7 @@ def RunShellWithReturnCode(command, print_output=False,
   p.wait()
   errout = p.stderr.read()
   if print_output and errout:
-    print >>sys.stderr, errout
+    print(errout, file=sys.stderr)
   p.stdout.close()
   p.stderr.close()
   return output, p.returncode
@@ -629,11 +631,11 @@ class VersionControlSystem(object):
     """Show an "are you sure?" prompt if there are unknown files."""
     unknown_files = self.GetUnknownFiles()
     if unknown_files:
-      print "The following files are not added to version control:"
+      print("The following files are not added to version control:")
       for line in unknown_files:
-        print line
+        print(line)
       prompt = "Are you sure to continue?(y/N) "
-      answer = raw_input(prompt).strip()
+      answer = input(prompt).strip()
       if answer != "y":
         ErrorExit("User aborted")
 
@@ -685,13 +687,13 @@ class VersionControlSystem(object):
       else:
         type = "current"
       if len(content) > MAX_UPLOAD_SIZE:
-        print ("Not uploading the %s file for %s because it's too large." %
-               (type, filename))
+        print(("Not uploading the %s file for %s because it's too large." %
+               (type, filename)))
         file_too_large = True
         content = ""
       checksum = md5.new(content).hexdigest()
       if options.verbose > 0 and not file_too_large:
-        print "Uploading %s file for %s" % (type, filename)
+        print("Uploading %s file for %s" % (type, filename))
       url = "/%d/upload_content/%d/%d" % (int(issue), int(patchset), file_id)
       form_fields = [("filename", filename),
                      ("status", status),
@@ -770,8 +772,8 @@ class SubversionVCS(VersionControlSystem):
       words = line.split()
       if len(words) == 2 and words[0] == "URL:":
         url = words[1]
-        scheme, netloc, path, params, query, fragment = urlparse.urlparse(url)
-        username, netloc = urllib.splituser(netloc)
+        scheme, netloc, path, params, query, fragment = six.moves.urllib.parse.urlparse(url)
+        username, netloc = six.moves.urllib.parse.splituser(netloc)
         if username:
           logging.info("Removed username from base URL")
         if netloc.endswith("svn.python.org"):
@@ -789,12 +791,12 @@ class SubversionVCS(VersionControlSystem):
           logging.info("Guessed CollabNet base = %s", base)
         elif netloc.endswith(".googlecode.com"):
           path = path + "/"
-          base = urlparse.urlunparse(("http", netloc, path, params,
+          base = six.moves.urllib.parse.urlunparse(("http", netloc, path, params,
                                       query, fragment))
           logging.info("Guessed Google Code base = %s", base)
         else:
           path = path + "/"
-          base = urlparse.urlunparse((scheme, netloc, path, params,
+          base = six.moves.urllib.parse.urlunparse((scheme, netloc, path, params,
                                       query, fragment))
           logging.info("Guessed base = %s", base)
         return base
@@ -1202,8 +1204,8 @@ def UploadSeparatePatches(issue, rpc_server, patchset, data, options):
   rv = []
   for patch in patches:
     if len(patch[1]) > MAX_UPLOAD_SIZE:
-      print ("Not uploading the patch for " + patch[0] +
-             " because the file is too large.")
+      print(("Not uploading the patch for " + patch[0] +
+             " because the file is too large."))
       continue
     form_fields = [("filename", patch[0])]
     if not options.download_base:
@@ -1211,7 +1213,7 @@ def UploadSeparatePatches(issue, rpc_server, patchset, data, options):
     files = [("data", "data.diff", patch[1])]
     ctype, body = EncodeMultipartFormData(form_fields, files)
     url = "/%d/upload_patch/%d" % (int(issue), int(patchset))
-    print "Uploading patch for " + patch[0]
+    print("Uploading patch for " + patch[0])
     response_body = rpc_server.Send(url, body, content_type=ctype)
     lines = response_body.splitlines()
     if not lines or lines[0] != "OK":
@@ -1238,7 +1240,8 @@ def GuessVCS(options):
     out, returncode = RunShellWithReturnCode(["hg", "root"])
     if returncode == 0:
       return MercurialVCS(options, out.strip())
-  except OSError, (errno, message):
+  except OSError as xxx_todo_changeme:
+    (errno, message) = xxx_todo_changeme.args
     if errno != 2:  # ENOENT -- they don't have hg installed.
       raise
 
@@ -1254,7 +1257,8 @@ def GuessVCS(options):
                                               "--is-inside-work-tree"])
     if returncode == 0:
       return GitVCS(options)
-  except OSError, (errno, message):
+  except OSError as xxx_todo_changeme1:
+    (errno, message) = xxx_todo_changeme1.args
     if errno != 2:  # ENOENT -- they don't have git installed.
       raise
 
@@ -1301,12 +1305,12 @@ def RealMain(argv, data=None):
     data = vcs.GenerateDiff(args)
   files = vcs.GetBaseFiles(data)
   if verbosity >= 1:
-    print "Upload server:", options.server, "(change with -s/--server)"
+    print("Upload server:", options.server, "(change with -s/--server)")
   if options.issue:
     prompt = "Message describing this patch set: "
   else:
     prompt = "New issue subject: "
-  message = options.message or raw_input(prompt).strip()
+  message = options.message or input(prompt).strip()
   if not message:
     ErrorExit("A non-empty message is required")
   rpc_server = GetRpcServer(options)
@@ -1339,7 +1343,7 @@ def RealMain(argv, data=None):
   # Send a hash of all the base file so the server can determine if a copy
   # already exists in an earlier patchset.
   base_hashes = ""
-  for file, info in files.iteritems():
+  for file, info in files.items():
     if not info[0] is None:
       checksum = md5.new(info[0]).hexdigest()
       if base_hashes:
@@ -1353,7 +1357,7 @@ def RealMain(argv, data=None):
   if not options.download_base:
     form_fields.append(("content_upload", "1"))
   if len(data) > MAX_UPLOAD_SIZE:
-    print "Patch is large, so uploading file patches separately."
+    print("Patch is large, so uploading file patches separately.")
     uploaded_diff_file = []
     form_fields.append(("separate_patches", "1"))
   else:
@@ -1393,7 +1397,7 @@ def main():
   try:
     RealMain(sys.argv)
   except KeyboardInterrupt:
-    print
+    print()
     StatusUpdate("Interrupted.")
     sys.exit(1)
 
diff --git a/security/nss/gtests/google_test/gtest/test/googletest-env-var-test.py b/security/nss/gtests/google_test/gtest/test/googletest-env-var-test.py
index 02c3655c39..1eb3f9c8e7 100644
--- a/security/nss/gtests/google_test/gtest/test/googletest-env-var-test.py
+++ b/security/nss/gtests/google_test/gtest/test/googletest-env-var-test.py
@@ -31,6 +31,7 @@
 
 """Verifies that Google Test correctly parses environment variables."""
 
+from __future__ import print_function
 import os
 import gtest_test_utils
 
@@ -45,8 +46,8 @@ environ = os.environ.copy()
 
 def AssertEq(expected, actual):
   if expected != actual:
-    print('Expected: %s' % (expected,))
-    print('  Actual: %s' % (actual,))
+    print(('Expected: %s' % (expected,)))
+    print(('  Actual: %s' % (actual,)))
     raise AssertionError
 
 
diff --git a/security/nss/gtests/google_test/gtest/test/googletest-throw-on-failure-test.py b/security/nss/gtests/google_test/gtest/test/googletest-throw-on-failure-test.py
index ea627c479d..028e43ff3f 100644
--- a/security/nss/gtests/google_test/gtest/test/googletest-throw-on-failure-test.py
+++ b/security/nss/gtests/google_test/gtest/test/googletest-throw-on-failure-test.py
@@ -35,6 +35,7 @@ This script invokes googletest-throw-on-failure-test_ (a program written with
 Google Test) with different environments and command line flags.
 """
 
+from __future__ import print_function
 import os
 import gtest_test_utils
 
@@ -68,7 +69,7 @@ def SetEnvVar(env_var, value):
 def Run(command):
   """Runs a command; returns True/False if its exit code is/isn't 0."""
 
-  print('Running "%s". . .' % ' '.join(command))
+  print(('Running "%s". . .' % ' '.join(command)))
   p = gtest_test_utils.Subprocess(command)
   return p.exited and p.exit_code == 0
 
diff --git a/security/nss/gtests/google_test/gtest/test/googletest-uninitialized-test.py b/security/nss/gtests/google_test/gtest/test/googletest-uninitialized-test.py
index 69595a0dde..5b726cdda8 100644
--- a/security/nss/gtests/google_test/gtest/test/googletest-uninitialized-test.py
+++ b/security/nss/gtests/google_test/gtest/test/googletest-uninitialized-test.py
@@ -31,6 +31,7 @@
 
 """Verifies that Google Test warns the user when not initialized properly."""
 
+from __future__ import print_function
 import gtest_test_utils
 
 COMMAND = gtest_test_utils.GetTestExecutablePath('googletest-uninitialized-test_')
@@ -43,8 +44,8 @@ def Assert(condition):
 
 def AssertEq(expected, actual):
   if expected != actual:
-    print('Expected: %s' % (expected,))
-    print('  Actual: %s' % (actual,))
+    print(('Expected: %s' % (expected,)))
+    print(('  Actual: %s' % (actual,)))
     raise AssertionError
 
 
diff --git a/security/nss/gtests/google_test/gtest/test/gtest_test_utils.py b/security/nss/gtests/google_test/gtest/test/gtest_test_utils.py
index d0c24466a4..3b73f136eb 100755
--- a/security/nss/gtests/google_test/gtest/test/gtest_test_utils.py
+++ b/security/nss/gtests/google_test/gtest/test/gtest_test_utils.py
@@ -31,6 +31,7 @@
 # Suppresses the 'Import not at the top of the file' lint complaint.
 # pylint: disable-msg=C6204
 
+from __future__ import print_function
 import os
 import sys
 
@@ -173,7 +174,7 @@ def GetTestExecutablePath(executable_name, build_dir=None):
         'Unable to find the test binary "%s". Please make sure to provide\n'
         'a path to the binary via the --build_dir flag or the BUILD_DIR\n'
         'environment variable.' % path)
-    print >> sys.stderr, message
+    print(message, file=sys.stderr)
     sys.exit(1)
 
   return path
diff --git a/security/nss/gtests/google_test/gtest/test/gtest_xml_test_utils.py b/security/nss/gtests/google_test/gtest/test/gtest_xml_test_utils.py
index ec42c62c3b..be5df6e0e5 100755
--- a/security/nss/gtests/google_test/gtest/test/gtest_xml_test_utils.py
+++ b/security/nss/gtests/google_test/gtest/test/gtest_xml_test_utils.py
@@ -74,8 +74,8 @@ class GTestXMLTestCase(gtest_test_utils.TestCase):
     self.assertEquals(
         expected_attributes.length, actual_attributes.length,
         'attribute numbers differ in element %s:\nExpected: %r\nActual: %r' % (
-            actual_node.tagName, expected_attributes.keys(),
-            actual_attributes.keys()))
+            actual_node.tagName, list(expected_attributes.keys()),
+            list(actual_attributes.keys())))
     for i in range(expected_attributes.length):
       expected_attr = expected_attributes.item(i)
       actual_attr = actual_attributes.get(expected_attr.name)
diff --git a/services/common/tests/mach_commands.py b/services/common/tests/mach_commands.py
index b57fa3aa26..ad016dbf3f 100644
--- a/services/common/tests/mach_commands.py
+++ b/services/common/tests/mach_commands.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 import mozpack.path as mozpath
 
@@ -92,7 +91,7 @@ class SyncTestCommands(MachCommandBase):
             ]
 
         profile_dir = mkdtemp()
-        print 'Created profile directory: %s' % profile_dir
+        print('Created profile directory: %s' % profile_dir)
 
         try:
             env = {'XPCSHELL_TEST_PROFILE_DIR': profile_dir}
@@ -101,7 +100,7 @@ class SyncTestCommands(MachCommandBase):
             return proc.wait()
 
         finally:
-            print 'Removing profile directory %s' % profile_dir
+            print('Removing profile directory %s' % profile_dir)
             rmtree(profile_dir)
 
     @Command('storage-server', category='services',
diff --git a/taskcluster/taskgraph/create.py b/taskcluster/taskgraph/create.py
index f577f88731..e41d89fbdf 100644
--- a/taskcluster/taskgraph/create.py
+++ b/taskcluster/taskgraph/create.py
@@ -24,7 +24,7 @@ CONCURRENCY = 50
 
 
 def create_tasks(taskgraph, label_to_taskid, params):
-    taskid_to_label = {t: l for l, t in label_to_taskid.iteritems()}
+    taskid_to_label = {t: l for l, t in label_to_taskid.items()}
 
     session = requests.Session()
 
@@ -85,7 +85,7 @@ def create_tasks(taskgraph, label_to_taskid, params):
                                        taskid_to_label[task_id], task_def)
 
         # Wait for all futures to complete.
-        for f in futures.as_completed(fs.values()):
+        for f in futures.as_completed(list(fs.values())):
             f.result()
 
 
@@ -113,10 +113,10 @@ def resolve_timestamps(now, task_def):
         if isinstance(val, list):
             return [recurse(v) for v in val]
         elif isinstance(val, dict):
-            if val.keys() == ['relative-datestamp']:
+            if list(val.keys()) == ['relative-datestamp']:
                 return json_time_from_now(val['relative-datestamp'], now)
             else:
-                return {k: recurse(v) for k, v in val.iteritems()}
+                return {k: recurse(v) for k, v in val.items()}
         else:
             return val
     return recurse(task_def)
diff --git a/taskcluster/taskgraph/decision.py b/taskcluster/taskgraph/decision.py
index d6460390fb..caba3442c7 100644
--- a/taskcluster/taskgraph/decision.py
+++ b/taskcluster/taskgraph/decision.py
@@ -95,7 +95,7 @@ def taskgraph_decision(options):
     _, _ = TaskGraph.from_json(full_task_json)
 
     # write out the target task set to allow reproducing this as input
-    write_artifact('target-tasks.json', tgg.target_task_set.tasks.keys())
+    write_artifact('target-tasks.json', list(tgg.target_task_set.tasks.keys()))
 
     # write out the optimized task graph to describe what will actually happen,
     # and the map of labels to taskids
diff --git a/taskcluster/taskgraph/docker.py b/taskcluster/taskgraph/docker.py
index 8159fd5a4a..16b19dc02d 100644
--- a/taskcluster/taskgraph/docker.py
+++ b/taskcluster/taskgraph/docker.py
@@ -11,7 +11,7 @@ import os
 import subprocess
 import tarfile
 import tempfile
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 import which
 
 from taskgraph.util import docker
@@ -28,7 +28,7 @@ def load_image_by_name(image_name):
 
     image_index_url = INDEX_URL.format('mozilla-central', image_name, context_hash)
     print("Fetching", image_index_url)
-    task = json.load(urllib2.urlopen(image_index_url))
+    task = json.load(six.moves.urllib.request.urlopen(image_index_url))
 
     return load_image_by_task_id(task['taskId'])
 
@@ -51,8 +51,8 @@ def load_image_by_task_id(task_id):
     print("Determining image name")
     tf = tarfile.open(filename)
     repositories = json.load(tf.extractfile('repositories'))
-    name = repositories.keys()[0]
-    tag = repositories[name].keys()[0]
+    name = list(repositories.keys())[0]
+    tag = list(repositories[name].keys())[0]
     name = '{}:{}'.format(name, tag)
     print("Image name:", name)
 
diff --git a/taskcluster/taskgraph/generator.py b/taskcluster/taskgraph/generator.py
index 809ed1f5c0..ec31625061 100644
--- a/taskcluster/taskgraph/generator.py
+++ b/taskcluster/taskgraph/generator.py
@@ -155,7 +155,7 @@ class TaskGraphGenerator(object):
         # in post-order
         kinds = {kind.name: kind for kind in self._load_kinds()}
         edges = set()
-        for kind in kinds.itervalues():
+        for kind in kinds.values():
             for dep in kind.config.get('kind-dependencies', []):
                 edges.add((kind.name, dep, 'kind-dependency'))
         kind_graph = Graph(set(kinds), edges)
@@ -211,7 +211,7 @@ class TaskGraphGenerator(object):
     def _run_until(self, name):
         while name not in self._run_results:
             try:
-                k, v = self._run.next()
+                k, v = next(self._run)
             except StopIteration:
                 raise AttributeError("No such run result {}".format(name))
             self._run_results[k] = v
diff --git a/taskcluster/taskgraph/optimize.py b/taskcluster/taskgraph/optimize.py
index 120e6807ba..855666c87b 100644
--- a/taskcluster/taskgraph/optimize.py
+++ b/taskcluster/taskgraph/optimize.py
@@ -51,10 +51,10 @@ def resolve_task_references(label, task_def, taskid_for_edge_name):
         if isinstance(val, list):
             return [recurse(v) for v in val]
         elif isinstance(val, dict):
-            if val.keys() == ['task-reference']:
+            if list(val.keys()) == ['task-reference']:
                 return TASK_REFERENCE_PATTERN.sub(repl, val['task-reference'])
             else:
-                return {k: recurse(v) for k, v in val.iteritems()}
+                return {k: recurse(v) for k, v in val.items()}
         else:
             return val
     return recurse(task_def)
@@ -78,7 +78,7 @@ def annotate_task_graph(target_task_graph, params, do_not_optimize,
         named_task_dependencies = named_links_dict.get(label, {})
 
         # check whether any dependencies have been optimized away
-        dependencies = [target_task_graph.tasks[l] for l in named_task_dependencies.itervalues()]
+        dependencies = [target_task_graph.tasks[l] for l in named_task_dependencies.values()]
         for t in dependencies:
             if t.optimized and not t.task_id:
                 raise Exception(
@@ -134,9 +134,9 @@ def get_subgraph(annotated_task_graph, named_links_dict, label_to_taskid):
         task.task_id = label_to_taskid[label] = slugid()
         named_task_dependencies = {
                 name: label_to_taskid[label]
-                for name, label in named_links_dict.get(label, {}).iteritems()}
+                for name, label in named_links_dict.get(label, {}.items())}
         task.task = resolve_task_references(task.label, task.task, named_task_dependencies)
-        task.task.setdefault('dependencies', []).extend(named_task_dependencies.itervalues())
+        task.task.setdefault('dependencies', []).extend(named_task_dependencies.values())
         tasks_by_taskid[task.task_id] = task
 
     # resolve edges to taskIds
diff --git a/taskcluster/taskgraph/target_tasks.py b/taskcluster/taskgraph/target_tasks.py
index d2b3f5a7f0..08a3f9c4ce 100644
--- a/taskcluster/taskgraph/target_tasks.py
+++ b/taskcluster/taskgraph/target_tasks.py
@@ -40,7 +40,7 @@ def target_tasks_try_option_syntax(full_task_graph, parameters):
     """Generate a list of target tasks based on try syntax in
     parameters['message'] and, for context, the full task graph."""
     options = try_option_syntax.TryOptionSyntax(parameters['message'], full_task_graph)
-    target_tasks_labels = [t.label for t in full_task_graph.tasks.itervalues()
+    target_tasks_labels = [t.label for t in full_task_graph.tasks.values()
                            if options.task_matches(t.attributes)]
 
     # If the developer wants test jobs to be rebuilt N times we add that value here
@@ -80,7 +80,7 @@ def target_tasks_default(full_task_graph, parameters):
             if project in RELEASE_PROJECTS:
                 return True
         return project in run_on_projects
-    return [l for l, t in full_task_graph.tasks.iteritems() if filter(t)]
+    return [l for l, t in full_task_graph.tasks.items() if list(filter(t))]
 
 
 @_target_task('ash_tasks')
@@ -102,7 +102,7 @@ def target_tasks_ash(full_task_graph, parameters):
         if task.attributes['kind'] == 'upload-symbols':
             return False
         return True
-    return [l for l, t in full_task_graph.tasks.iteritems() if filter(t)]
+    return [l for l, t in full_task_graph.tasks.items() if list(filter(t))]
 
 
 @_target_task('cedar_tasks')
@@ -118,4 +118,4 @@ def target_tasks_cedar(full_task_graph, parameters):
                     or 'xpcshell' in task.attributes['unittest_suite']):
                 return False
         return True
-    return [l for l, t in full_task_graph.tasks.iteritems() if filter(t)]
+    return [l for l, t in full_task_graph.tasks.items() if list(filter(t))]
